cpu 386
org	0100h

mov al, 0x13
int 0x10

;Get 8x16 font
mov ax, 1130h
mov bh, 06h
int 10h

push es
pop fs

push 0xa000
pop es
xor di,di

allpixels:

mov ax, di
xor dx, dx
mov cx, 320
div cx

;ax has the row, we want 
sub al, 36
jb borderpixel
cmp al, 128
ja borderpixel
;Offset in font row
shr al, 3
mov si, ax

;dx has the x position
mov ax, dx
mov cl, 64
div cl

;Store the font subposition
mov cl, ah
shr cl, 3

;string index
movzx bx, al
;Read the character
mov bl, byte [bx+string]
shl bx, 4
add bx, bp
;read the font data
mov al, byte [fs:bx+si]
shl al, cl
jnc nextpixel
mov byte [es:di], 0x10

jmp nextpixel
borderpixel:
mov byte [es:di], al

nextpixel:
inc di
jnz allpixels

mov bx, 0x0001
push pass0
push 100
push 100
jmp filler
pass0:

mov bl, 0x0004
push pass1
push 90
push (320*45)/50
jmp filler
pass1:

mov bx, 0x000e
push pass2
push 60
push (320*35)/50
jmp filler
pass2:

;Fill the letters
mov bx, 0x100f
push passc
push 100
push 16
jmp filler
passc:
;mov bx, 0x100f
push passo
push 54
push 100
jmp filler
passo:
;mov bx, 0x100f
push passm
push 77
push 168
jmp filler
passm:
push passp
push 127
push 213
jmp filler
passp:
push passo2
push 127
push 292
jmp filler
passo2:

waitkill:
in al, 60h
dec al
jnz waitkill

ret

filler:

inc bp
test bp, 0x1f
jnz skipwait

mov dx,3dah
wait_first:
;in al, dx
;test al, 8
;jnz wait_first
wait_second:
in al, dx
test al, 8
jz wait_second

skipwait:

cmp sp, 0xfffe-2
jne fillpass
ret

fillpass:
pop ax
pop cx

or ax, ax
js filler
cmp ax, 320
jge filler

or cx, cx
js filler
cmp cl, 200
jae filler

imul si, cx, 320
add si, ax
cmp byte [es:si], bh
jne filler

mov byte [es:si], bl

inc ax
push cx 
push ax
dec ax
dec ax
push cx
push ax
inc ax
inc cx
push cx
push ax
dec cx
dec cx
push cx
push ax

jmp filler

string:
db 'COMPO'
